library IEEE,mylib;
use IEEE.STD_LOGIC_1164.ALL;
use mylib.vtx_pack.ALL;

entity refresh is
    Port ( clk : in std_logic;
           not_locked : in std_logic;
           mode_set : in std_logic;
           mrs : out std_logic;
           start_init : out std_logic;
           ddr_csn : out std_logic;
           ddr_clke : out std_logic;
           ref : out std_logic);
end refresh;

architecture refresh_arch of refresh is
signal clke: std_logic := '0';
signal tc: std_logic := '0';
signal carry: std_logic := '0';
signal startup: std_logic_vector(4 downto 0) := "00000";
begin
ddr_clke <= clke;
-- refresh signal generator
process(clk,not_locked)
begin
  if(not_locked = '1')then
    tc <= '0';
    ref <= '0';
    clke <= '0';
    start_init <= '0';
    mrs <= '0';
    ddr_csn <= '1';
  elsif(clk'event and clk = '1')then
    ddr_csn <= '0';
    mrs <= tc and clke and startup(1) and not startup(0);
    if(startup = "11011" and tc = '1')then
      start_init <= '1';
      clke <= '1';
    else
      start_init <= '0';
    end if;
    tc <= carry;
    ref <= tc and clke;
  end if;
end process;
startup_cntr: l_cntr
  generic map(N => 5)
  port map(
    d => gnd16(4 downto 0),
    load => '0',
    reset => not_locked,
    set => mode_set,
    ec => tc,
    en_cnt => '1',
    clk => clk,
    q => startup);
ref_cntr: l_cntr
  generic map(N => 10)
  port map(
    d => gnd16(9 downto 0),
    load => '0',
    reset => not_locked,
    set => '0',
    ec => '1',
    en_cnt => '1',
    clk => clk,
    carry => carry);
end refresh_arch;
